//+------------------------------------------------------------------+
//|                                               iCointegration.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Cointegration"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

input string SecSymbol="USDCAD";
input ushort iPeriod=15;
ushort period=5;
double buffer[],point1,point2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   period=MathMax(period,iPeriod);

   point1=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
   point2=SymbolInfoDouble(SecSymbol,SYMBOL_POINT);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   if(rates_total>prev_calculated)
     {
      ArraySetAsSeries(open,true);
      int bars=prev_calculated>0? rates_total-prev_calculated-1:MathMin(rates_total,iBars(SecSymbol,PERIOD_CURRENT))-period-1;

      for(int i=bars; i>=0; i--)
        {
         double sum0=0,sum1=0,sum2=0,sum3=0;
         for(int j=0; j<period; j++)
           {
            int pos=i+j;
            double p1=open[pos]/point1,
                   p2=iOpen(SecSymbol,PERIOD_CURRENT,pos)/point2;
            sum0=sum0+p1;
            sum1=sum1+p2;
            sum2=sum2+p1*p2;
            sum3=sum3+p2*p2;
           }

         double denom=period*sum3-sum1*sum1;

         if(denom>0)
            buffer[i]=open[i]/point1-((period*sum2-sum0*sum1)*iOpen(SecSymbol,PERIOD_CURRENT,i)/point2-sum0*sum3+sum1*sum2)/denom;
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
