//+------------------------------------------------------------------+
//|                                               sCointegration.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property script_show_inputs

input ushort iPeriod=50;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   int period=MathMax(5,iPeriod),
       handle=FileOpen("Cointegration.csv",FILE_WRITE|FILE_CSV);

   for(int i=0; i<SymbolsTotal(true)-1; i++)
     {
      string sym1=SymbolName(i,true);
      double point1=SymbolInfoDouble(sym1,SYMBOL_POINT);
      for(int j=i+1; j<SymbolsTotal(true); j++)
        {
         string sym2=SymbolName(j,true);
         int bars=MathMin(iBars(sym1,PERIOD_CURRENT),iBars(sym2,PERIOD_CURRENT))-period-1,cnt=0;
         double last_c=0,point2=SymbolInfoDouble(sym2,SYMBOL_POINT);

         for(int k=bars; k>=0; k--)
           {
            int n=0;
            double sum0=0,sum1=0,sum2=0,sum3=0;
            for(int l=0; l<period; l++)
              {
               int pos=k+l;
               double p1=iOpen(sym1,PERIOD_CURRENT,pos)/point1,
                      p2=iOpen(sym2,PERIOD_CURRENT,pos)/point2;

               sum0=sum0+p1;
               sum1=sum1+p2;
               sum2=sum2+p1*p2;
               sum3=sum3+p2*p2;
               n++;
              }

            double denom=n*sum3-sum1*sum1,
                   coint=iOpen(sym1,PERIOD_CURRENT,k)/point1-((n*sum2-sum0*sum1)*iOpen(sym2,PERIOD_CURRENT,k)/point2-sum0*sum3+sum1*sum2)/denom;

            if((last_c>0 && coint<=0) || (last_c<0 && coint>=0))
               cnt++;

            last_c=coint;
           }

         FileWrite(handle,sym1,sym2,100.0*cnt/bars);
        }
     }

   FileClose(handle);
   Alert("Done");
//---
  }
//+------------------------------------------------------------------+
